LightOJ - 1422 Halloween Costumes (区间DP)

Description

Gappu has a very busy weekend ahead of him. Because, next weekend is Halloween, and he is planning to attend as many parties as he can. Since it‘s Halloween, these
parties are all costume parties, Gappu always selects his costumes in such a way that it blends with his friends, that is, when he is attending the party, arranged by his comic-book-fan friends, he will go with the costume of Superman, but when the party is
arranged contest-buddies, he would go with the costume of ‘Chinese Postman‘.

Since he is going to attend a number of parties on the Halloween night, and wear costumes accordingly, he will be changing his costumes a number of times. So, to make things a little easier, he may put on costumes one over another (that is he may wear the
uniform for the postman, over the superman costume). Before each party he can take off some of the costumes, or wear a new one. That is, if he is wearing the Postman uniform over the Superman costume, and wants to go to a party in Superman costume, he can
take off the Postman uniform, or he can wear a new Superman uniform. But, keep in mind that, Gappu doesn‘t like to wear dresses without cleaning them first, so, after taking off the Postman uniform, he cannot use that again in the Halloween night, if he needs
the Postman costume again, he will have to use a new one. He can take off any number of costumes, and if he takes off
k of the costumes, that will be the last k ones (e.g. if he wears costume
A before costume B, to take off A, first he has to remove
B).

Given the parties and the costumes, find the minimum number of costumes Gappu will need in the Halloween night.

Input

Input starts with an integer T (≤ 200), denoting the number of test cases.

Each case starts with a line containing an integer N(1 ≤ N ≤ 100) denoting the number of parties. Next line contains
N integers, where the ith integer
ci(1 ≤ ci ≤ 100)
denotes the costume he will be wearing in party
i. He will attend party 1 first, then party 2, and so on.

Output

For each case, print the case number and the minimum number of required costumes.

Sample Input

2

4

1 2 1 2

7

1 2 1 1 3 2 1

Sample Output

Case 1: 3

Case 2: 4

题意:给你n天分别要穿的衣服,可以套着穿,但是一旦脱下来就不能再穿了,问这n天最少要准备几件衣服。

思路:区间dp[i][j]表示从第i天到第j天的最少准备几件,那么对于第i天要么是穿了就脱了,要么是判断之后的某天是否有重复的,那么问题就变成了区间问题了

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn = 110;

int type[maxn], n;
int dp[maxn][maxn];

int main() {
	int t, cas = 1;
	scanf("%d\n", &t);
	while (t--) {
		scanf("%d", &n);
		for (int i = 1; i <= n; i++)
			scanf("%d", &type[i]);
		memset(dp, 0, sizeof(dp));
		for (int i = 1; i <= n; i++)
			for (int j = i; j <= n; j++)
				dp[i][j] = j-i+1;

		for (int i = n-1; i >= 1; i--)
			for (int j = i+1; j <= n; j++) {
				dp[i][j] = dp[i+1][j] + 1;
				for (int k = i; k <= j; k++)
					if (type[i] == type[k])
						dp[i][j] = min(dp[i][j], dp[i+1][k-1]+dp[k][j]);
			}

		printf("Case %d: %d\n", cas++, dp[1][n]);
	}
	return 0;
}
时间: 2024-08-07 04:32:07

LightOJ - 1422 Halloween Costumes (区间DP)的相关文章

LightOJ 1422 Halloween Costumes (区间dp 好题)

1422 - Halloween Costumes PDF (English) Statistics Forum Time Limit: 2 second(s) Memory Limit: 32 MB Gappu has a very busy weekend ahead of him. Because, nextweekend is Halloween, and he is planning to attend as many parties as he can.Since it's Hall

LightOJ 1422 Halloween Costumes 区间dp

题意:给你n天需要穿的衣服的样式,每次可以套着穿衣服,脱掉的衣服就不能再穿了,问至少要带多少条衣服才能参加所有宴会 思路:dp[i][j]代表i-j天最少要带的衣服 从后向前dp 区间从大到小 更新dp[i][j]时有两种情况 考虑第i天穿的衣服 1:第i天穿的衣服在之后不再穿了 那么 dp[i][j]=dp[i+1][j]+1; 2:第i天穿的衣服与i+1到j的某一天共用,那么dp[i][j]=min(dp[i][j],dp[i+1][k-1],dp[k][j]),前提是第i天和第k天需要的礼

Light OJ 1422 Halloween Costumes 区间DP基础题

Halloween Costumes 题目链接: http://lightoj.com/volume_showproblem.php?problem=1422 题意: Gappu想要去参加一些party,他去每个party都要把特定编号的服装穿在外边,他可以穿上或者脱掉服装(脱掉的服装不能再穿一次,但是可以穿一件相同编号新的服装,最近穿的服装会套在之前穿的服装的外边),问Gappu最少需要准备多少套服装. 题解: 设dp[i][j]为区间 i 到 j (设len为区间长度,j=i+len)内最少

Light OJ 1422 - Halloween Costumes(区间DP 最少穿几件)

http://www.cnblogs.com/kuangbin/archive/2013/04/29/3051392.html http://www.cnblogs.com/ziyi--caolu/archive/2013/08/01/3229668.html http://www.cfanz.cn/index.php?c=article&a=read&id=172173 #include <iostream> #include <string> #include

LightOJ 1422 Halloween Costumes 【 区间dp 】

区间dp的第一题----- 看题解看了好多~~终于看懂了---55555 dp[i][j] 表示第i天到第j天至少需要多少件衣服 那么第i件衣服只被第i天占用的话, dp[i][j] = dp[i+1][j] + 1 如果不只被第i天占用的话,那么假设在第k天和第i天穿一样的衣服,dp[i][j] = dp[i+1][k-1] + dp[k][j] 这一篇讲得很详细~ http://blog.csdn.net/tc_to_top/article/details/44830317 1 #inclu

LightOJ 1422 Halloween Costumes 【区间DP】

题目链接:http://lightoj.com/volume_showproblem.php?problem=1422 解法:dp[i][j]=min(1+dp[i+1][j],dp[i+1][k-1]+dp[k][j]) 代码: #include <stdio.h> #include <ctime> #include <math.h> #include <limits.h> #include <complex> #include <str

【LightOJ 1422】Halloween Costumes(区间DP)

题 题意 告诉我们每天要穿第几号衣服,规定可以套好多衣服,所以每天可以套上一件新的该号衣服,也可以脱掉一直到该号衣服在最外面.求最少需要几件衣服. 分析 DP,dp[i][j]表示第i天到第j天不脱第i天之前的衣服最少需要的衣服数量,那就可以由和第j天穿一样的衣服的第k天转移过来,或者再套一件第j天的衣服. 状态转移方程:dp[i][j]=min(dp[i][k]+dp[k+1][j-1],dp[i][j-1]+1)(i≤k<j,a[j]==a[k]) 算的时候i从大到小算,因为算dp[i][j

LightOJ(1422)——Halloween Costumes

首先,我还是表扬一下自己,开始独立思考了,虽然说最后的想法是错误的,但是至少已经很接近了.所以,再接再厉吧! 题意: 现在那个人要去参加一个聚会,然后总共有n天,每天所要求穿的服饰的序号分别为c[i]. 这个人可以一次性穿上1件衣服,或者一次性脱下任意多件衣服.当然也可以在衣服外面套衣服. 并且如果这件衣服已经被脱下的话,那么它下次不能再次被穿上,如果我们还需要这件衣服的话,那么我们就只能重新再去买另外一件了. 最后问你,如果要参加完所有的派对,那么他所需要的最少的衣服数量是多少. 比如说第一个

LightOJ 1422 Halloween Costumes

dp[i]][j]=min(dp[i+1][j]+1,dp[i+1][k-1]+dp[k][j]) 表示第i天到j的最小数量.如果第i天的衣服只自己穿的话,不考虑后面的就是dp[i][j]=dp[i+1][j]+1.否则就是dp[i][j]=dp[i+1][k-1]+dp[k][j],其中第k天的衣服和第i天一样,这就是考虑第i天以后还有和它穿的衣服一样的情况 1 //#pragma comment(linker, "/STACK:167772160")//手动扩栈~~~~hdu 用c